clear
format compact
format long e
global A D counter mults SHIFTA ;
A=sparse(A);
D=sparse(D);
dgaptol=1e-9;   % added by henry
n = 1000;
%tmults = zeros(2,1) ;
tcounter = zeros(2,1) ;        % added by henry - tmults commented out
avecount = zeros(2,1) ;        % added by henry - tmults commented out
titers = zeros(2,1) ;        % added by henry - tmults commented out
aveiters = zeros(2,1) ;        % added by henry - tmults commented out
viters=zeros(2,20);      % added by henry
relfeasxopt=0;
reloptcond=0;
reldualoptcond=0;
ij=0;
itermax=0;
for r = [ 100 10 ]    %  added by henry for outside loop
    ij=ij+1;          % added by henry
    for i = 1:20
    d = rand(n,1) - .5 ;
    u = rand(n,1) - .5 ;
    u = u*(sqrt(2)/norm(u)) ;
    b = rand(n,1) - .5 ;
    b = b/norm(b) ;
    y = d.*u ;
    c = u'*y ;
    A = diag(d) - y*u' - u*y' + (u*c)*u' ;
    d = diag(A) ;
    B = abs(A - spdiags(d,[0],n,n)) ;
    SHIFTA = max(d+sum(B)') ;

    OPTIONS.issym = 1; % know the matrix is symmetric
    OPTIONS.disp = 0; % no display of the output for eig

    [v,d] = eigs('mult',n,1,OPTIONS) ;
    d(1)+SHIFTA

    j = 0 ;

%   for r = [ 100 10 ]
        display('radius:') ;
        r
%       [lopt, xopt, topt, fopt, iter, gap,flag_conj,tarn1f,t0f] = ...
%           newtrust4(b,r) ;
%       updated newtrust4b code with updated output line, added by henry
        A=sparse(A);
        D=sparse(D);
        [xopt,fopt,lopt,lambdamin,muup,mulow,iter,flag] = ...
                  newtrust(b,r,dgaptol);
        xAopt=  (A-lopt* eye(size(A,1))  ) \b;
        relfeasxopt(ij,i)=abs(r-norm(xopt))/r;
        reloptcond(ij,i)=-norm(  (A-lopt* eye(size(A,1)) )*xopt-b )/fopt;
        philopt=lopt*r^2-b'*xAopt;    %dual function value
        reldualoptcond(ij,i)=(r^2-norm(xAopt)^2)/philopt;
        mults
        xopt = xopt*(r/norm(xopt)) ;
        t = b - A*xopt ;
        mu = t'*xopt/(r^2) ;
        err = norm(t-xopt*mu);
        j = j + 1 ;
%       tmults(j) = tmults(j) + mults ;
        tcounter(ij)=tcounter(ij)+counter;    %added by henry
        titers(ij)=titers(ij)+iter;    %added by henry
        viters(ij,i)=iter;         % total record of iterations
        if iter > itermax,
           save xprb2 A b r dgaptol viters
           itermax=iter;
        end
    end
%avemults = tmults/20
avecount(ij)=tcounter(ij)/20  %added by henry
aveiters(ij)=titers(ij)/20  %added by henry
end
!rm prb2.diary
diary prb2.diary
disp('average of matrix multiplications')
[avecount]
disp('individual iterations per problem')
[viters]
disp('relative feasibility for each problem')
[relfeasxopt]
disp('relative optimality error for each problem')
[reloptcond]
diary off
