clear
format compact
format long e

global A D counter mults SHIFTA ;
A=sparse(A);
D=sparse(D);
dgaptol=1e-9;   % added by henry
tcounter = zeros ;        % added by henry - tmults commented out
avecount = zeros ;        % added by henry - tmults commented out
titers = zeros ;        % added by henry - tmults commented out
aveiters = zeros ;        % added by henry - tmults commented out
viters=zeros;      % added by henry
relfeasxopt=zeros;      % added by henry
reloptcond=zeros;      % added by henry
itermax=0;
N = 16 ;
n = N*N ;
e = ones(n,1) ;
d = e ;
for i = N:N:n
    d(i) = 0 ;
end

A = spdiags([ -e -d 2*e ], [-N -1 0 ], n , n) ;
A = (A+A')  - 5*speye(n) ;
tmults = 0 ;
d = diag(A) ;
B = abs(A - spdiags(d,[0],n,n)) ;
SHIFTA = max(d+sum(B)') ;
OPTIONS.issym = 1; % know the matrix is symmetric
OPTIONS.disp = 0; % no display of the output for eig

[v,d] = eigs('mult',n,1,OPTIONS) ;
d(1)+SHIFTA
v = v/norm(v) ;

for i = 1:20
    b = rand(n,1) ;
    b = b - v*(v'*b) ;
    r   = 100 ;
%   [lopt, xopt, topt, fopt, iter, gap,flag_conj,tarn1f,t0f] = ...
%       newtrust4(b,r) ;
    A=sparse(A);
    D=sparse(D);
    [xopt,fopt,lopt,lambdamin,muup,mulow,iter,flag] = ...
                  newtrust(b,r,dgaptol);
    relfeasxopt(i)=abs(r-norm(xopt))/r;
    reloptcond(i)=-norm(  (A-lopt* eye(size(A,1)) )*xopt-b )/fopt;
    iter
    mults
    tmults = tmults + mults ;
    xopt = xopt*(r/norm(xopt)) ;
    t = b - A*xopt ;
    mu = t'*xopt/(r^2) ;
    err = norm(t-xopt*mu)
    tcounter=tcounter+counter;    %added by henry
    titers=titers+iter;    %added by henry
    viters(i)=iter;         % total record of iterations
    if iter > itermax,
       save xprb3 A b r dgaptol viters
       itermax=iter;
    end

end
avemults = tmults/20
avecount=tcounter/20  %added by henry
aveiters=titers/20  %added by henry
!rm prb3.diary
diary prb3.diary
disp('average of matrix multiplications')
[avecount]
disp('individual iterations per problem')
[viters]
disp('relative feasibility for each problem')
[relfeasxopt]
disp('relative optimality error for each problem')
[reloptcond]
diary off
